//  startRecording and stopRecording used to be called from an html loaded into an iframe
//  using pgGotoURL and this used script src app.js
//  the code from app.js is now here.
URL = window.URL || window.webkitURL;

var gumStream; 						//stream from getUserMedia()
var recorder; 						//WebAudioRecorder object
var input; 							//MediaStreamAudioSourceNode  we'll be recording
var encodingType; 					//holds selected encoding for resulting audio (file)
var encodeAfterRecord = true;       // when to encode

// shim for AudioContext when it's not avb. 
var AudioContext = window.AudioContext || window.webkitAudioContext;
var audioContext; //new audio context to help us record

// var encodingTypeSelect = document.getElementById("encodingTypeSelect");
// var recordButton = document.getElementById("recordButton");
// var stopButton = document.getElementById("stopButton");

//add events to those 2 buttons
// recordButton.addEventListener("click", startRecording);
// stopButton.addEventListener("click", stopRecording);


// function setEncodingType(type)
//     {
//     encodingType = type;
//     }


    function startRecording() {
	console.log("startRecording() called");
  
    if (!encodingType)
    {
     encodingType = 'mp3';
    }

	/*
		Simple constraints object, for more advanced features see
		https://addpipe.com/blog/audio-constraints-getusermedia/
	*/
   
    var constraints = { audio: true, video: false }

    /*
    	We're using the standard promise based getUserMedia() 
    	https://developer.mozilla.org/en-US/docs/Web/API/MediaDevices/getUserMedia
	*/

	navigator.mediaDevices.getUserMedia(constraints).then(function(stream) {
		console.log("getUserMedia() success, stream created, initializing WebAudioRecorder...");

		/*
			create an audio context after getUserMedia is called
			sampleRate might change after getUserMedia is called, like it does on macOS when recording through AirPods
			the sampleRate defaults to the one set in your OS for your playback device

		*/
		audioContext = new AudioContext();

		//update the format 
		///document.getElementById("formats").innerHTML="Format: 2 channel "+encodingTypeSelect.options[encodingTypeSelect.selectedIndex].value+" @ "+audioContext.sampleRate/1000+"kHz"

		//assign to gumStream for later use
		gumStream = stream;
		
		/* use the stream */
		input = audioContext.createMediaStreamSource(stream);
		
		tbfunction_pgTBObjSet("lightOn","visible",true);
        //stop the input from playing back through the speakers
		//input.connect(audioContext.destination)

		//get the encoding 
		//encodingType = encodingTypeSelect.options[encodingTypeSelect.selectedIndex].value;
// 		 encodingType = "mp3"
		//disable the encoding selector
   
//     top.tbfunction_pgTBObjSet("lightOn","visible",true);
//     top.tbfunction_pgTBObjSet("lightOff","visible",false);
    
// 		encodingTypeSelect.disabled = true;

		recorder = new WebAudioRecorder(input, {
		  workerDir: "../js/", // must end with slash
		  encoding: encodingType,
		  numChannels:2, //2 is the default, mp3 encoding supports only 2
		  onEncoderLoading: function(recorder, encoding) {
		    // show "loading encoder..." display
		    console.log("Loading "+encoding+" encoder...");
		  },
		  onEncoderLoaded: function(recorder, encoding) {
		    // hide "loading encoder..." display
		    console.log(encoding+" encoder loaded");
		  }
		});

		recorder.onComplete = function(recorder, blob) { 
			console.log("Encoding complete");
			//createDownloadLink(blob,recorder.encoding);
            playback(blob);
// 			encodingTypeSelect.disabled = false;
		}

		recorder.setOptions({
		  timeLimit:120,
		  encodeAfterRecord:encodeAfterRecord,
	      ogg: {quality: 0.5},
	      mp3: {bitRate: 160}
	    });

		//start the recording process
		recorder.startRecording();

		 console.log("Recording started");

	}).catch(function(err) {
	  	//enable the record button if getUSerMedia() fails
//     	recordButton.disabled = false;
//     	stopButton.disabled = true;
         console.log("Error");
	});

	//disable the record button
//     recordButton.disabled = true;
//     stopButton.disabled = false;
}

    function stopRecording() {
	console.log("stopRecording() called");
	
	//stop microphone access
	gumStream.getAudioTracks()[0].stop();

	//disable the stop button
// 	stopButton.disabled = true;
// 	recordButton.disabled = false;
	
	//tell the recorder to finish the recording (stop recording + encode the recorded audio)
	recorder.finishRecording();

	console.log('Recording stopped');
    tbfunction_pgTBObjSet("lightOn","visible", false);
    tbfunction_pgTBObjSet("stop","enabled", false);
    }

function playback(blob) {
// This uses pgSoundLoader.
tbfunction_pgTBObjSet("start","enabled", true);
var url = URL.createObjectURL(blob);
top.tbfunction_pgTBObjSet("player","user", url);
// holdUrl = url;
// holdBlob = blob;
}